﻿using FarPoint.Win.Spread.Model;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GroupRemoveRow
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            fpSpread1_Sheet1.ColumnCount = 4;
            fpSpread1_Sheet1.RowCount = 4;
            fpSpread1_Sheet1.Columns[0].Label = "Name";
            fpSpread1_Sheet1.Columns[1].Label = "Gender";
            fpSpread1_Sheet1.Columns[2].Label = "Remuneration";
            fpSpread1_Sheet1.Columns[3].Label = "Occupation";
            fpSpread1_Sheet1.Cells[0, 0].Value = "Jack";
            fpSpread1_Sheet1.Cells[0, 1].Value = "Male";
            fpSpread1_Sheet1.Cells[0, 2].Value = "3000 USD";
            fpSpread1_Sheet1.Cells[0, 3].Value = "Teacher";
            fpSpread1_Sheet1.Cells[1, 0].Value = "Tommy";
            fpSpread1_Sheet1.Cells[1, 1].Value = "Male";
            fpSpread1_Sheet1.Cells[1, 2].Value = "3000 USD";
            fpSpread1_Sheet1.Cells[1, 3].Value = "Developer";
            fpSpread1_Sheet1.Cells[2, 0].Value = "Cassie";
            fpSpread1_Sheet1.Cells[2, 1].Value = "FeMale";
            fpSpread1_Sheet1.Cells[2, 2].Value = "3200 USD";
            fpSpread1_Sheet1.Cells[2, 3].Value = "Teacher";
            fpSpread1_Sheet1.Cells[3, 0].Value = "Mary";
            fpSpread1_Sheet1.Cells[3, 1].Value = "FeMale";
            fpSpread1_Sheet1.Cells[3, 2].Value = "2700 USD";
            fpSpread1_Sheet1.Cells[3, 3].Value = "Accountant";
            fpSpread1_Sheet1.Columns[2].Width = 100;
            fpSpread1_Sheet1.Columns[3].Width = 100;
            fpSpread1.AllowColumnMove = true;
            fpSpread1.ActiveSheet.GroupBarInfo.Visible = true;
            fpSpread1.ActiveSheet.AllowGroup = true;            
        }

        private void getModelBtn_Click(object sender, EventArgs e)
        {
            GroupDataModel mainGroupDM = new GroupDataModel(fpSpread1_Sheet1.Models.Data);

            while (mainGroupDM.TargetModel is GroupDataModel)
            {
                mainGroupDM = (mainGroupDM.TargetModel as GroupDataModel);
            }

            var  defaultSheetDataModel = mainGroupDM.TargetModel as DefaultSheetDataModel;

            if(defaultSheetDataModel != null)
            {
                if(defaultSheetDataModel.RowCount > 1)
                {
                    defaultSheetDataModel.RemoveRow(1);  // row is removed based on the index of row in original data model
                }
            }
        }
    }
}
